// dd.h

#include <ddraw.h>

#define MAX_MODE	4

typedef struct mode_t
{
	DWORD	width;
	DWORD	height;
	int		zoom;
} SCREEN_MODE;

#ifndef DD_CPP

extern LPDIRECTDRAW	lpDDrawOld;
extern LPDIRECTDRAW2	lpDDraw;
extern LPDIRECTDRAWSURFACE	lpPrimarySurface;
extern LPDIRECTDRAWSURFACE	lpBackSurface;
extern LPDIRECTDRAWCLIPPER	lpClipper;
//extern LPDIRECTDRAWSURFACE	lpSurface;

//extern DWORD dwScreenWidth;
//extern DWORD dwScreenHeight;
extern SCREEN_MODE	mode[MAX_MODE];
extern int curMode;
extern int numMode;

extern BOOL bFullScreen;
extern BOOL bActiveApp;
//extern int zoom;

extern HWND hwnd;

extern RECT rcWnd;

extern HPALETTE	hPaletteApp;

#endif // DD_CPP

BOOL InitDDraw(void);
BOOL InitSurfaces(BOOL bSetFullScreen);
void ChangeWindowMode(void);
BOOL RestoreSurfaces(void);
BOOL ReleaseSurfaces(void);
BOOL ReleaseDDraw(void);
void ZoomWindow(/*int zoom*/);
void OnMoveWindow(int x, int y);
